import { ContentBlock, DraftBlockRenderMap, DraftDecorator, DraftEditorCommand, DraftHandleValue, EditorState } from 'draft-js';
import { EditorPluginFunctions } from 'draft-js-plugins-editor';
import { KeyboardEvent } from 'react';
import { TabIndentOptions } from './@behaviors';
import { LinkComponentProps, LinkDecoratorOptions } from './@decorators';
export interface FluentMarkdownPluginLinkComponentProps extends LinkComponentProps {
}
export interface FluentMarkdownPluginLinkOptions extends LinkDecoratorOptions {
}
export interface FluentMarkdownPluginIndentOptions extends TabIndentOptions {
}
export interface FluentMarkdownPluginOptions {
    block?: boolean;
    link?: FluentMarkdownPluginLinkOptions;
    indent?: FluentMarkdownPluginIndentOptions;
}
export declare class FluentMarkdownPlugin {
    blockRenderMap: DraftBlockRenderMap;
    decorators: DraftDecorator[];
    private featureSelectionLocked;
    private featureSelectionLockTimer;
    private atomicDescriptorMap;
    private blockDescriptorBuilderMap;
    private features;
    private indentOptions;
    constructor({ block, link: linkOptions, indent: indentOptions, }: FluentMarkdownPluginOptions);
    onTab: (event: KeyboardEvent, { getEditorState, setEditorState }: EditorPluginFunctions) => DraftHandleValue;
    blockRendererFn: (block: ContentBlock, pluginFunctions: EditorPluginFunctions) => unknown;
    handleBeforeInput: (input: string, editorState: EditorState, { setEditorState }: EditorPluginFunctions) => DraftHandleValue;
    handleReturn: (event: KeyboardEvent, editorState: EditorState, { setEditorState }: EditorPluginFunctions) => DraftHandleValue;
    handleKeyCommand: (command: DraftEditorCommand, editorState: EditorState, { setEditorState }: EditorPluginFunctions) => DraftHandleValue;
    handlePastedText: (text: string, _html: string, editorState: EditorState, { setEditorState }: EditorPluginFunctions) => DraftHandleValue;
    onChange: (editorState: EditorState) => EditorState;
    private triggerFeature;
}
export declare function createFluentMarkdownPlugin(options?: FluentMarkdownPluginOptions): FluentMarkdownPlugin;
//# sourceMappingURL=plugin.d.ts.map